#include <stdint.h>

/* Struktur TimeStamp */
typedef struct
{
    uint32_t sec;
    uint16_t xusec;
}TimeStampStruct;


/* The structure that holds the telegrams */
typedef struct 
{
    TimeStampStruct timestamp;    /* timestamp for received telegrams */
    uint16_t data_length;            /* length of data  */
    uint8_t data[64];               /* telegram data */
} telegram_t;

#define RX_TEL_BUF_SIZE        5        /* Receive telegram ring-buffer */

telegram_t RXtemp;           /* used for filling out a message */

telegram_t rx_tel_buffer[RX_TEL_BUF_SIZE];    /* Receive telegram ring-buffer */
uint8_t rx_tel_buf_cnt;                            /* RX: counter for telegrams in buffer */
telegram_t *rx_tel_in_ptr;                    /* RX: write pointer in buffer */
telegram_t *rx_tel_out_ptr;                    /* RX: read pointer in buffer */



/*****************************************************************************
   main()
*****************************************************************************/
int main(void)
{
    uint8_t i;
    uint8_t *p;
    
    p=(uint8_t *) &RXtemp;
    rx_tel_in_ptr = rx_tel_buffer;
    
    for(i=0;i<sizeof(RXtemp);i++)
    *p++=i;
    
    for(;;)
    {
        if (rx_tel_buf_cnt < RX_TEL_BUF_SIZE)
        {
            rx_tel_buf_cnt++;
            *rx_tel_in_ptr++ = RXtemp; 
        }
        if (rx_tel_in_ptr >= rx_tel_buffer + RX_TEL_BUF_SIZE) /* Pointer wrapping */
        rx_tel_in_ptr = rx_tel_buffer;
    }

    return(0);
}


